%% Simulations of complete model

x0 = zeros(9,1);
x0(1) = 0.0001;
x0(2) = 0.0001;
x0(3) = 0.0001;
x0(4) = 0.0001;
x0(5) = 0.0001;
x0(6) = 0.0001;
x0(7) = 0.0001;
x0(8) = 0.0001;
x0(9) = 0.0001;
%% 

% Blocking efficiency

to = [0;1000];
m = linspace(0, 0.01, 2000);
min_ = zeros(i,1);
max_ = zeros(i,1);
l = zeros(i,1);
n = zeros(i,1);
for i = 1:length(m)
    Konsrna = m(i);
    n = m.';
    %l(i) = -log10(m(i));
    glu = 0;
    [to,x] = ode15s(@(t,x) EDOS_Unespv2(t,x,glu,Konsrna),to,x0);
    min_(i) = x(70,9);
    %h = plot(t,x(:,9));
    glu = 1000;
    [to,x] = ode15s(@(t,x) EDOS_Unespv2(t,x,glu,Konsrna),to,x0);
    max_(i) = x(70,9);
    dif(i) = ((max_(i)-min_(i))/max_(i))*100;
    
end

tdif = dif.'

ttt = m.';
h = plot(n,tdif)

xlabel ('Ksonrna (nM)');
ylabel ('Blocking efficiency (%)');
legend ('0 - 0.01 nM') ;
%% Glucose impulse

Konsrna = 4.41e-3;
to = linspace(0,6000);
m = linspace(1, 1000, 10);
for i =1:length(m)
    glu = m(i) ;
    [to,x] = ode15s(@(t,y) EDOS_Unespv2(t,y,glu,Konsrna),to,x0);
    plot(to,x(:,9)); 
    hold on
    %plot(to,x(:,1));
    %plot(to,x(:,2));
    %plot(to,x(:,3));
    %plot(to,x(:,4));
    %plot(to,x(:,5));
    %plot(to,x(:,6));
    %plot(to,x(:,7));
    %plot(to,x(:,8));
end
xlabel ('Time (s)');
ylabel ('Insulin concentration (nM)');
legend ( 'Glucose 1 nM', 'Glucose 100 nM', 'Glucose 200 nM', 'Glucose 300 nM', 'Glucose 400 nM', 'Glucose 500 nM', 'Glucose 600 nM', 'Glucose 700 nM', 'Glucose 800 nM', 'Glucose 900 nM', 'Glucose 1000 nM') ;


%% %% ON and OFF
Konsrna = 4e-3;
to = linspace(0,6000,100);
for i=1:length(to)
    if  i < 500
        glu(i) = 0;
    else
        glu(i) = 1000;
    end
end
    [t,x] = ode15s(@(t,y) EDOS_Unespv2(t,y,glu,Konsrna),to,x0);
    %h = plot(t,x(:,9)) 
    plot(t,x(:,9)) 
    hold on
    plot(t,glu)

xlabel ('Time (s)');
ylabel ('Insulin concentration (nM)');
legend ( 'Glucose 1 nM', 'Glucose 200 nM', 'Glucose 400 nM', 'Glucose 600 nM', 'Glucose 800 nM', 'Glucose 1 nM') ;

% Conclusion: Seems like the glucose concentration doesn't matter


%% %% %% ON and OFF
Konsrna = 4.411;
t = [0;6000];
m = [0; 1000];
for i =1:length(m); 
    glu = m(i) ;
    [t,x] = ode15s(@(t,y) EDOS_Unespv2(t,y,glu,Konsrna),t,x0);
    h = plot(to,glu) 
    hold on    
end
xlabel ('Time (s)');
ylabel ('Insulin concentration (nM)');
legend ( 'Glucose 1 nM', 'Glucose 200 nM', 'Glucose 400 nM', 'Glucose 600 nM', 'Glucose 800 nM', 'Glucose 1 nM') ;

% Conclusion: Seems like the glucose concentration doesn't matter

%% With glucose (different concentrations)
Konsrna = 4.411;
to = [0;6000];
m = [0; 1000] ;

%if i == 1; 
   % pl1 = x(:,9); 
%else
   [to,x] = ode15s(@(t,y) EDOS_Unespv2(t,y,glu,Konsrna),to,x0);
   % pl2 = x(:,9);
   % ppp = pl2 - pl1;
%    min_ = sol.x(:,9)
    h = plot(to,x(:,9))
    %hold on    
%end

xlabel ('Time (s)');
ylabel ('Insulin concentration (nM)');
legend ( 'Glucose 1 nM', 'Glucose 200 nM', 'Glucose 400 nM', 'Glucose 600 nM', 'Glucose 800 nM', 'Glucose 1 nM') ;

% Conclusion: Seems like the glucose concentration doesn't matter

% Graph showing different kd influence on leakage

%% %% With glucose (different concentrations)
Konsrna = 4.41e-3;
t = [0;10000];
m = linspace(0, 1000, 5) ;
for i =1:length(m); 
    glu = m(i) ;
    [to,x] = ode15s(@(t,y) EDOS_Unespv2(t,y,glu,Konsrna),t,x0);
    h = plot(to,x(:,9))
    hold on    
end
xlabel ('Time (s)');
ylabel ('Insulin concentration (nM)');
legend ( 'Glucose 1 nM', 'Glucose 200 nM', 'Glucose 400 nM', 'Glucose 600 nM', 'Glucose 800 nM', 'Glucose 1 nM') ;

% Conclusion: Seems like the glucose concentration doesn't matter

% Graph showing different kon / koff influence on leakage
%% Influence Kon, Koff

to = [0;10000];
%m = [1; 5; 10; 15; 20];
m = [0;10000];
glu = 100;
for i = 1:length(m);
    Konsrna = m(i);
    [to,x] = ode15s(@(t,y) EDOS_Unespv2(t,y,glu,Konsrna),to,x0);
    h = plot(to,x(:,9))
    
    hold on    
end

xlabel ('Time (s)');
ylabel ('Insulin concentration (nM)');
legend ( 'Kd 10-2 nM', 'Kd 0.2*10-1 nM', 'Kd 0.4 10-1 nM', 'Kd 0.6 10-1 nM', 'Kd 10-1 nM' ) ;


